--ADD NEW COLUMN TO TABLE tables_registry
ALTER TABLE tables_registry ADD nums INT;
--SET PARENT TO ALL GLOBAL FILTERS
UPDATE filters SET parent_id = (SELECT id FROM filters WHERE name = 'All') WHERE parent_id IS NULL AND name != 'All';
--CREATE FUNCTION TO SET PARENT TO ALL PRIVATE FILTERS
CREATE OR REPLACE FUNCTION fold_queries(  )
RETURNS BOOLEAN AS $$
DECLARE
    gid INT;
    pid INT;
    tmp_cursor CURSOR FOR SELECT glob.id, priv.id 
    FROM 
	filters AS glob, filters AS priv 
    WHERE 
	    priv.owner_id IS NOT NULL 
	AND glob.owner_id IS NULL 
	AND glob.name != 'All' 
	AND (position(glob.query || ' ' in priv.query) != 0 OR position( ' ' || glob.query in priv.query) != 0)
	AND
	    glob.id IN (
	        SELECT filters.id FROM filters INNER JOIN filterusers ON filters.id = filterusers.filter_id INNER JOIN users ON users.id = filterusers.user_id WHERE users.id = priv.owner_id AND filters.owner_id IS NULL
		UNION
		SELECT filters.id FROM filters INNER JOIN filtergroups AS fg ON filters.id = fg.filter_id INNER JOIN usergroup AS ug ON fg.group_id = ug.group_id INNER JOIN users ON ug.user_id = users.id WHERE users.id = priv.owner_id AND filters.owner_id IS NULL
	);
BEGIN
    OPEN tmp_cursor;
    LOOP
	FETCH tmp_cursor INTO gid, pid;
	IF NOT FOUND THEN
	    EXIT;
	END IF;
	UPDATE filters SET parent_id = gid WHERE id = pid;
    END LOOP;
    CLOSE tmp_cursor;

    RETURN TRUE;
EXCEPTION
    WHEN OTHERS THEN
        RAISE NOTICE 'Error number:%', SQLSTATE;
        RETURN FALSE;
END;
$$
LANGUAGE plpgsql;
--SET PARENT TO ALL PRIVATE FILTERS
SELECT fold_queries();
--DROP FUNCTION fold_queries
DROP FUNCTION fold_queries();
--UPDATE db VERSION
UPDATE service SET version = 7;
